#include <stdio.h>
#include <iostream>
#include<cstdlib>
#include<vector>
#include <gmp.h>
#include <mpfr.h>
using namespace std;
#include "../header_files/linked_mpfr_lists.h"
#include "../header_files/main_prob_funcs_new.h"
#include "../header_files/generate_Tav_list.h"
#include "../header_files/get_relevant_Tav_range.h"


//Declaration of functions
bool check_if_in_D1(unsigned long int m_i,unsigned long int m_C);
unsigned long int get_j_start(unsigned long int i,unsigned long int beta);
unsigned long int get_j_end(unsigned long int i,unsigned long int alpha);
unsigned long int get_R(unsigned long int m_C,unsigned long int n_C,unsigned long int m_A,unsigned long int n_A);
//

unsigned long int get_R(unsigned long int m_C,unsigned long int n_C,unsigned long int m_A,unsigned long int n_A)
{
  unsigned long int i,b_val;
  for (i=0; i<=n_C; i++)
    {
      if (!(n_A*i>m_A*n_C))
	{
	  b_val=i;
	}
    }
  return b_val;
}


bool check_if_in_D1(unsigned long int m_i,unsigned long int m_C)
{
  bool b_val=false;
  if (m_i<=m_C)
    {
      b_val=true;
    }
  return b_val;
}

unsigned long int get_j_start(unsigned long int i,unsigned long int beta)
{
  unsigned long int b_val;
  b_val=0;
  if (i>beta)
    {
      b_val=i-beta;
    }
  return b_val;
}


unsigned long int get_j_end(unsigned long int i,unsigned long int alpha)
{
  unsigned long int b_val;
  b_val=i;
  if (alpha<i)
    {
      b_val=alpha;
    }
  return b_val;
}


int main(int argc, char *argv[])
{
  ListNode* Mpfr_tav_vect;
  ListNode* at_node=NULL;
  ListNode* a_new_node=NULL;
  ListNode* temp_node=NULL;
  mpfr_t* an_mpfr_ptr=NULL;

  mpq_t mpq_A,mpq_B,mpq_C,mpq_D,mpq_E,mpq_F;
  mpfr_t mpfr_nom_tot,mpfr_den_tot,mpfr_subtot,mpfr_outer;
  mp_rnd_t ROUND_MODE=GMP_RNDN; //GMP_RNDU;GMP_RNDD;GMP_RNDN
  mp_prec_t MY_PREC;

  vector<string> args;
  int arg_i, temp_int;

  unsigned long int low_tav_val,high_tav_val;
  unsigned long int R,n,m_C,l_C,m_A,l_A;
  unsigned long int m_i,l_i;
  unsigned long int c_nom,c_den,x_nom,x_den,t_ac_nom,t_ac_den;


  bool prior_uniform = true;
  bool U_is_derived = true;

  unsigned long int tav_j,i,j,j_start,j_end,alpha,beta;
  long double out_val,den_out_val,nom_out_val,tav_error;
  //DEBUGS
  //double debug_out;
  //int debug_int;

  for (arg_i=1; arg_i<argc; arg_i++)
    {
      args.push_back(argv[arg_i]);
    }
  if (args.size()==14)
    {
      temp_int=atoi(args[0].c_str());
      if ( !(temp_int == 1) )
	{
	  prior_uniform = false;
	}
      temp_int=atoi(args[1].c_str());
      if ( !(temp_int == 1) )
	{
	  U_is_derived = false;
	}
      temp_int=atoi(args[2].c_str());
      m_C=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[3].c_str());
      n=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[4].c_str());
      m_A=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[5].c_str());
      l_A=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[6].c_str());
      c_nom=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[7].c_str());
      c_den=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[8].c_str());
      x_nom=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[9].c_str());
      x_den=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[10].c_str());
      t_ac_nom=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[11].c_str());
      t_ac_den=static_cast<unsigned long int>(temp_int);
      MY_PREC=atoi(args[12].c_str());
      tav_error=atof(args[13].c_str());
    }
  else
    {
      cout<<"Number of arguments should be 14!!\n";
    }

//INITIALISE MPFR AND GMP VARIABLES
  mpfr_init2(mpfr_den_tot,MY_PREC);
  mpfr_init2(mpfr_nom_tot,MY_PREC);
  mpfr_init2(mpfr_subtot,MY_PREC);
  mpfr_init2(mpfr_outer,MY_PREC);
  mpq_init(mpq_A);
  mpq_init(mpq_B);
  mpq_init(mpq_C);
  mpq_init(mpq_D);
  mpq_init(mpq_E);
  mpq_init(mpq_F);


  Mpfr_tav_vect=function_Tav_1D(n,t_ac_nom,t_ac_den, ROUND_MODE,MY_PREC);
  get_tav_range(&low_tav_val,&high_tav_val,n,tav_error, Mpfr_tav_vect, ROUND_MODE,MY_PREC);
//
//cout<<"Low tav val "<<low_tav_val<<endl;
//cout<<"High tav val "<<high_tav_val<<endl;
//
  //MAIN CALCULATIONS WITH STUCTURE:
  /*
    A_den=0
    A_nom=0
    for (m_i=0;m_i<=R;m_i++)
      {
	B=0
	at_lC=n-at_mC;
	for (alpha=0;alpha<=m_i;alpha++)
	  {
	    for (beta=0;beta<=l_i;beta++)
	      {
		C=0
		for (i=0;i<=alpha+beta;i++)
	          {
	            D=0
	            j_start=get_max(0,i-beta)
	            j_end=get_min(i,alpha)
		    for (j=j_start;j<=j_end;j++)
		      {
			D=D+func_S(j,i-j,mA,lA)*func_bin(alpha+beta-i,alpha-j,x)
		      }//j-loop
		    C=C+D*func_bin(alpha+beta,i,c)
		  }//i-loop
		B=B+C*func_H(alpha,beta,at_mC,at_lC)*func_G(n,alpha+beta,t)
              } //beta-loop
	  }//alpha-loop
	A_den+=B
	if (m_i<=mC)
	  {
	    A_nom+=B
	  }
      }//at_mC-loop
      return A_nom/A_den
  */


  R=get_R(m_C,n,m_A,m_A+l_A);
//
//cout<<"R= "<<R<<endl;
//
  mpfr_set_ui(mpfr_nom_tot,0,ROUND_MODE);
  mpfr_set_ui(mpfr_den_tot,0,ROUND_MODE);
  for (m_i=0;m_i<=R;m_i++)
    {
//
//cout<<"\tm_i= "<<m_i<<endl;
//
       mpfr_set_ui(mpfr_subtot,0,ROUND_MODE);
       l_i=n-m_i;
       for (alpha=0;alpha<=m_i;alpha++)
	 {
	   for (beta=0;beta<=l_i;beta++)
             {
	       if ((alpha+beta>=low_tav_val) && (alpha+beta<=high_tav_val))
	         {
//
//cout<<" "<<alpha+beta;
//
		   mpq_set_ui(mpq_B,0,1);
		   for (i=0;i<=alpha+beta;i++)
		     {
		       mpq_set_ui(mpq_D,0,1);
		       j_start=get_j_start(i,beta);
		       j_end=get_j_end(i,alpha);
		       for (j=j_start;j<=j_end;j++)
			 {
			   function_myBin(mpq_E,alpha+beta-i,alpha-j,x_nom,x_den);
			   function_S_generic(mpq_F,prior_uniform,U_is_derived,j,i,m_A,l_A);
			   mpq_mul(mpq_E,mpq_E,mpq_F);
			   mpq_canonicalize(mpq_E);
			   mpq_add(mpq_D,mpq_D,mpq_E);
			   mpq_canonicalize(mpq_D);
			 }//j-loop
		       function_myBin(mpq_C,alpha+beta,i,c_nom,c_den);
		       mpq_mul(mpq_C,mpq_C,mpq_D);
		       mpq_canonicalize(mpq_C);
		       mpq_add(mpq_B,mpq_B,mpq_C);
		       mpq_canonicalize(mpq_B);
		     }//i-loop
		   temp_node=Mpfr_tav_vect->GetBetaAlphaNode(Mpfr_tav_vect,n,alpha+beta);
		   an_mpfr_ptr=temp_node->GetMpfr();
		   mpfr_set(mpfr_outer,*an_mpfr_ptr,ROUND_MODE);
		   temp_node=NULL;
		   an_mpfr_ptr=NULL;
		   function_H(mpq_A,alpha,beta,m_i,l_i);
		   mpq_mul(mpq_A,mpq_A,mpq_B);
		   mpq_canonicalize(mpq_A);
		   mpfr_mul_q(mpfr_outer,mpfr_outer,mpq_A,ROUND_MODE);
		   mpfr_add(mpfr_subtot,mpfr_subtot,mpfr_outer,ROUND_MODE);
		 } //if alpha+beta in relevant Tav values
	     } //beta-loop
	 }//alpha-loop
       mpfr_add(mpfr_den_tot,mpfr_den_tot,mpfr_subtot,ROUND_MODE);
       if (check_if_in_D1(m_i,m_C))
	 {
           mpfr_add(mpfr_nom_tot,mpfr_nom_tot,mpfr_subtot,ROUND_MODE);
         }
    }//at_mi-loop
  mpq_set_ui(mpq_F,0,1);
  mpq_set_ui(mpq_E,0,1);
  mpq_set_ui(mpq_D,0,1);
  mpq_set_ui(mpq_C,0,1);
  mpq_set_ui(mpq_B,0,1);
  mpq_set_ui(mpq_A,0,1);
  mpfr_set_ui(mpfr_outer,0,ROUND_MODE);
  mpfr_set_ui(mpfr_subtot,0,ROUND_MODE);
  Mpfr_tav_vect->EraseList(Mpfr_tav_vect);
  nom_out_val=mpfr_get_ld(mpfr_nom_tot,ROUND_MODE);
  den_out_val=mpfr_get_ld(mpfr_den_tot,ROUND_MODE);
  mpfr_set_ui(mpfr_nom_tot,0,ROUND_MODE);
  mpfr_set_ui(mpfr_den_tot,0,ROUND_MODE);
  mpfr_free_cache();
  cout.precision(20);
  out_val=nom_out_val/(den_out_val+tav_error);
  cout<<out_val<<endl;
  out_val=(nom_out_val+tav_error)/(den_out_val+tav_error);
  cout<<out_val<<endl;
  return 0;
}

