#include <stdio.h>
#include <iostream>
#include<cstdlib>
#include<vector>
#include <gmp.h>
#include <mpfr.h>
using namespace std;
#include "../header_files/linked_mpfr_lists.h"
#include "../header_files/main_prob_funcs_new.h"
#include "../header_files/generate_Tav_list.h"
#include "../header_files/get_relevant_Tav_range.h"




//Declaration of functions
bool check_if_in_D1(unsigned long int m_i,unsigned long int m_C);
unsigned long int get_index_start(unsigned long int i,unsigned long int beta);
unsigned long int get_index_end(unsigned long int i,unsigned long int alpha);
unsigned long int get_R(unsigned long int m_C,unsigned long int n_C,unsigned long int m_A,unsigned long int n_A);
//

unsigned long int get_R(unsigned long int m_C,unsigned long int n_C,unsigned long int m_A,unsigned long int n_A)
{
  unsigned long int i,b_val;
  for (i=0; i<=n_C; i++)
    {
      if (!(n_A*i>m_A*n_C))
        {
          b_val=i;
        }
    }
  return b_val;
}

bool check_if_in_D1(unsigned long int m_i,unsigned long int m_C)
{
  bool b_val=false;
  if (m_i<=m_C)
    {
      b_val=true;
    }
  return b_val;
}

unsigned long int get_index_start(unsigned long int alpha,unsigned long int l_i)
{
  unsigned long int b_val;
  b_val=0;
  if (alpha>l_i)
    {
      b_val=alpha-l_i;
    }
  return b_val;
}


unsigned long int get_index_end(unsigned long int alpha,unsigned long int m_i)
{
  unsigned long int b_val;
  b_val=m_i;
  if (alpha<m_i)
    {
      b_val=alpha;
    }
  return b_val;
}

int main(int argc, char *argv[])
{
  ListNode* Mpfr_tav_mat;
  ListNode* at_node=NULL;
  ListNode* a_new_node=NULL;
  ListNode* temp_node=NULL;
  mpfr_t* an_mpfr_ptr=NULL;


  mpfr_t mpfr_A,mpfr_A_den,mpfr_B,mpfr_C,mpfr_D,mpfr_E;
  mpq_t mpq_F,mpq_G,mpq_H;
  mp_rnd_t ROUND_MODE=GMP_RNDN; //GMP_RNDU;GMP_RNDD;GMP_RNDN
  mp_prec_t MY_PREC;

  vector<string> args;
  int arg_i, temp_int;


  unsigned long int n,m_C,l_C,m_A,l_A;
  unsigned long int low_tav_val[1000];
  unsigned long int high_tav_val[1000];

  unsigned long int m_i,l_i;
  unsigned long int c_nom,c_den,x_nom,x_den,t_ac_nom,t_ac_den;
  unsigned long int R;


  bool prior_uniform = true;
  bool U_is_derived = true;

  unsigned long int tav_alpha,tav_j,i,j,j_end,alpha,beta,beta_start,beta_end;
  long double out_val,nom_out_val,den_out_val;
  long double tav_error;

  for (arg_i=1; arg_i<argc; arg_i++)
    {
      args.push_back(argv[arg_i]);
    }
  if (args.size()==14)
    {
      temp_int=atoi(args[0].c_str());
      if ( !(temp_int == 1) )
        {
          prior_uniform = false;
        }
      temp_int=atoi(args[1].c_str());
      if ( !(temp_int == 1) )
        {
          U_is_derived = false;
        }
      temp_int=atoi(args[2].c_str());
      m_C=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[3].c_str());
      n=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[4].c_str());
      m_A=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[5].c_str());
      l_A=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[6].c_str());
      c_nom=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[7].c_str());
      c_den=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[8].c_str());
      x_nom=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[9].c_str());
      x_den=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[10].c_str());
      t_ac_nom=static_cast<unsigned long int>(temp_int);
      temp_int=atoi(args[11].c_str());
      t_ac_den=static_cast<unsigned long int>(temp_int);
      MY_PREC=atoi(args[12].c_str());
      tav_error=atof(args[13].c_str());
    }
  else
    {
      cout<<"Number of arguments should be 14!!\n";
    }



//INITIALISE MPFR AND GMP VARIABLES

  mpfr_init2(mpfr_A,MY_PREC);
  mpfr_init2(mpfr_A_den,MY_PREC);
  mpfr_init2(mpfr_B,MY_PREC);
  mpfr_init2(mpfr_C,MY_PREC);
  mpfr_init2(mpfr_D,MY_PREC);
  mpfr_init2(mpfr_E,MY_PREC);
  mpq_init(mpq_F);
  mpq_init(mpq_G);
  mpq_init(mpq_H);



//GENERATE AND CALCULATE TAV_MAT
// Here all values are needed (0<=n<=m_C+l_C, 0<=k<=n)
  Mpfr_tav_mat=new ListNode(0,0,MY_PREC);
  at_node=Mpfr_tav_mat;
  mpfr_set_ui(mpfr_A,1,ROUND_MODE);
  at_node->SetMpfr(&mpfr_A,ROUND_MODE);

  low_tav_val[0]=0;
  high_tav_val[0]=n;

  for (tav_alpha=1;tav_alpha<=n;tav_alpha++)
    {
  //    cout<<"Calculating tav 84 for n="<<tav_alpha<<endl;
      for (tav_j=0;tav_j<=tav_alpha;tav_j++)
	{
	  a_new_node=new ListNode(tav_alpha,tav_j,MY_PREC);
	  at_node->SetNext(a_new_node);
	  if (!(t_ac_nom==0))
	    {
	      function_G(mpfr_A,tav_alpha,tav_j,t_ac_nom,t_ac_den,ROUND_MODE,MY_PREC);
	    }
	  else
	    {
	      if (tav_j==tav_alpha)
		{
		  mpfr_set_ui(mpfr_A,1,ROUND_MODE);
		}
	      else
		{
		  mpfr_set_ui(mpfr_A,0,ROUND_MODE);
		}
	    }
	  a_new_node->SetMpfr(&mpfr_A,ROUND_MODE);
	  at_node=a_new_node;
	}
      get_tav_range(&low_tav_val[tav_alpha],&high_tav_val[tav_alpha],tav_alpha,tav_error, Mpfr_tav_mat, ROUND_MODE,MY_PREC);
    }
  a_new_node=NULL;
  at_node=NULL;

//  for (tav_alpha=0;tav_alpha<=n;tav_alpha++)
//    {
//      cout<<tav_alpha<<" tav vals: "<<low_tav_val[tav_alpha]<<" "<<high_tav_val[tav_alpha]<<"\n";
//    }


  //MAIN CALCULATIONS WITH STUCTURE:
  /*
    A_nom=0
    A_den=0
    for (m_i=0;m_i<=n;m_i++)
      {
	    B=0
	    l_i=n-m_i;
	    for (alpha=0;alpha<=n;alpha++)
	      {
	        C=0
		beta_start=get_max(0,alpha-l_i)
		beta_end=get_min(alpha,m_i)
		for (beta=beta_start;beta<=beta_end;beta++)
		  {
		    D=0
		    for (i=0;i<=alpha;i++)
		      {
		        E=0
			j_start=0
			j_end=get_min(i,beta)
			for (j=j_start;j<=j_end;j++)
			  {
			    E=E+func_H(j,i-j,beta,alpha-beta)*func_S(j,i-j,mA,lA)
			  }//j-loop
			E=E*Tavare(alpha,i,t)
			D=D+E
		      }//i-loop

ONLY CHANCE FOR D TO BE LARGER THAN ZERO FOR x=0 IS m_i-beta=0 MEANING beta_start=beta_end=m_i
ONLY CHANCE FOR D TO BE LARGER THAN ZERO FOR x=1 IS n-m_i-(alpha-beta)=0 MEANING beta_start=beta_end=alpha-l_i
  
		    D=D*func_Bin(n-alpha,m_i-beta,x)
		    C=C+D
		  } //beta-loop
		  C=C*func_Bin(n,alpha,c)
		  B=B+C
	      }//alpha-loop
	    A_den=A_den+B
            if (m_i<=m_C) A_nom=A_nom+B
      }//m_i-loop

  */


  R=get_R(m_C,n,m_A,m_A+l_A);

//
//cout<<"mC nC "<<m_C<<" "<<n<<endl;
//cout<<"mA nA "<<m_A<<" "<<m_A+l_A<<endl;
//cout<<"Cnom Cden "<<c_nom<<" "<<c_den<<endl;
//cout<<"t_nom t_den "<<t_ac_nom<<" "<<t_ac_den<<endl;
//cout<<"R "<<R<<endl;
//


  mpfr_set_ui(mpfr_A_den,0,ROUND_MODE);
  mpfr_set_ui(mpfr_A,0,ROUND_MODE);
  for (m_i=0;m_i<=R;m_i++)
    {
      mpfr_set_ui(mpfr_B,0,ROUND_MODE);
      l_i=n-m_i;
      for (alpha=0;alpha<=n;alpha++)
	{
	  mpfr_set_ui(mpfr_C,0,ROUND_MODE);
	  //beta_start=get_index_start(alpha,l_i);
	  //beta_end=get_index_end(alpha,m_i);

	  if ((x_nom==x_den) || (x_nom==0))
            {
              if (x_nom==0)
                {
                  beta_start=get_index_end(alpha,m_i);
                  beta_end=get_index_end(alpha,m_i);
                }
              else
                {
                  beta_start=get_index_start(alpha,l_i);
                  beta_end=get_index_start(alpha,l_i);
                }
            }
          else
            {
              beta_start=get_index_start(alpha,l_i);
              beta_end=get_index_end(alpha,m_i);
            }
	  for (beta=beta_start;beta<=beta_end;beta++)
	    {
	      mpfr_set_ui(mpfr_D,0,ROUND_MODE);
	      for (i=0;i<=alpha;i++)
	        {
                  if ((i>=low_tav_val[alpha]) && (i<=high_tav_val[alpha]))
                    {
         	      mpq_set_ui(mpq_F,0,1);
		      j_end=get_index_end(i,beta);
		      for (j=0;j<=j_end;j++)
	                {
	                  function_H(mpq_G,j,i-j,beta,alpha-beta);
		          function_S_generic(mpq_H,prior_uniform,U_is_derived,j,i,m_A,l_A);
		          mpq_mul(mpq_G,mpq_G,mpq_H);
	                  mpq_canonicalize(mpq_G);
		          mpq_add(mpq_F,mpq_F,mpq_G);
		          mpq_canonicalize(mpq_F);
		        }//j-loop
		      temp_node=Mpfr_tav_mat->GetBetaAlphaNode(Mpfr_tav_mat,alpha,i);
		      an_mpfr_ptr=temp_node->GetMpfr();
		      mpfr_set(mpfr_E,*an_mpfr_ptr,ROUND_MODE);
		      temp_node=NULL;
		      an_mpfr_ptr=NULL;
		      mpfr_mul_q(mpfr_E,mpfr_E,mpq_F,ROUND_MODE);
		      mpfr_add(mpfr_D,mpfr_D,mpfr_E,ROUND_MODE);
                    }//if in relevant tav range
		}//i-loop
	      function_myBin(mpq_H,n-alpha,m_i-beta,x_nom,x_den);
	      mpfr_mul_q(mpfr_D,mpfr_D,mpq_H,ROUND_MODE);
	      mpfr_add(mpfr_C,mpfr_C,mpfr_D,ROUND_MODE);
	    } //beta-loop
	  function_myBin(mpq_H,n,alpha,c_nom,c_den);
	  mpfr_mul_q(mpfr_C,mpfr_C,mpq_H,ROUND_MODE);
	  mpfr_add(mpfr_B,mpfr_B,mpfr_C,ROUND_MODE);
	}//alpha-loop
      mpfr_add(mpfr_A_den,mpfr_A_den,mpfr_B,ROUND_MODE);
      if (check_if_in_D1(m_i,m_C))
        {
          mpfr_add(mpfr_A,mpfr_A,mpfr_B,ROUND_MODE);
        }
    }//m_i-loop


  Mpfr_tav_mat->EraseList(Mpfr_tav_mat);
  mpq_set_ui(mpq_H,0,1);
  mpq_set_ui(mpq_G,0,1);
  mpq_set_ui(mpq_F,0,1);
  mpfr_set_ui(mpfr_E,0,ROUND_MODE);
  mpfr_set_ui(mpfr_D,0,ROUND_MODE);
  mpfr_set_ui(mpfr_C,0,ROUND_MODE);
  mpfr_set_ui(mpfr_B,0,ROUND_MODE);
  nom_out_val=mpfr_get_ld(mpfr_A,ROUND_MODE);
  den_out_val=mpfr_get_ld(mpfr_A_den,ROUND_MODE);
  mpfr_set_ui(mpfr_A,0,ROUND_MODE);
  mpfr_set_ui(mpfr_A_den,0,ROUND_MODE);
  mpfr_free_cache();
  cout.precision(40);
  out_val=nom_out_val/(den_out_val+tav_error);
  cout<<out_val<<endl;
  out_val=(nom_out_val+tav_error)/(den_out_val+tav_error);
  cout<<out_val<<endl;
  return 0;
}


