import re
import sys
import subprocess

def check_U_is_correctly_defined(m_C,l_C,m_A,l_A):
    n_C=m_C+l_C
    n_A=m_A+l_A
    if (m_C*n_A>m_A*n_C):
        return 0
    else:
        return 1

def generate_out_str(t_ac_den,c_den,OUT_DICT):
    b_str='C horizontal/t_AC vertical\n'
    t_nom_list=sorted(OUT_DICT.keys())
    c_nom_list=sorted(OUT_DICT[t_nom_list[0]].keys())
    for c_nom in c_nom_list:	
       	b_str+='\t'+str(1.0*c_nom/c_den)
    b_str+='\n'
    for t_ac_nom in t_nom_list:
    	b_str+=str(1.0*t_ac_nom/t_ac_den)
	for c_nom in c_nom_list:
            	the_prob=OUT_DICT[t_ac_nom][c_nom]
            	b_str+='\t'+str(the_prob)
        b_str+='\n'
    return b_str
   


param_dict={}
temp_line = sys.stdin.readline()
while temp_line:
    if re.search('\S',temp_line):
        a_line=re.sub('\s','',temp_line)
        if not a_line[0]=='#':
            re_obj=re.search('^(\w+)=([^#]+)',a_line)
            if re_obj:
                param_dict.update({re_obj.group(1):re_obj.group(2)})
    temp_line = sys.stdin.readline()

print 'HEHEHE' 

try:
    tav_error=param_dict['tav_error']
    uniform_prior=int(param_dict['uniform_prior'])
    U_is_derived=int(param_dict['U_is_derived'])
    m_C=int(param_dict['m_C'])
    l_C=int(param_dict['l_C'])

    m_A=int(param_dict['m_A'])
    l_A=int(param_dict['l_A'])

    t_AC_den=int(param_dict['t_AC_den'])
    temp=param_dict['t_AC_nom_list']
    temp_list=re.split(',',temp)
    time_list_AC=[]
    for y in temp_list:
        time_list_AC+=[int(y)]

    c_den=int(param_dict['c_den'])
    temp=param_dict['c_nom_list']
    temp_list=re.split(',',temp)
    c_list=[]
    for y in temp_list:
        c_list+=[int(y)]
    the_prec=int(param_dict['the_prec'])
    file_name_base=param_dict['file_name_base']
except:
    print 'Need to pass a correct parameter setting file..' 
    print param_dict
    raw_input()


if (m_C+l_C>999):
    print "MAY NEED TO RECOMPILE - default array size = 1000"
    raw_input("continue? ctrl-C to stop..")



U_is_more_common_in_PopA=check_U_is_correctly_defined(m_C,l_C,m_A,l_A)
if (U_is_more_common_in_PopA==1):
    griff_prior_ok=1
    if not uniform_prior==1:
        if U_is_derived==1:
            if m_A==0:
                griff_prior_ok=0
        else:
            if l_A==0:
                griff_prior_ok=0
    file_name=file_name_base+'_genetic.txt'
    if griff_prior_ok==1:
        n=m_C+l_C
        print 'C list',c_list
        print 'T_AC list',time_list_AC
        min_prob_OUT_DICT={}
        max_prob_OUT_DICT={}
        for t_AC_nom in time_list_AC:
            min_prob_OUT_DICT.update({t_AC_nom:{}})
            max_prob_OUT_DICT.update({t_AC_nom:{}})
            print 'Calculating for t_AC =',1.0*t_AC_nom/t_AC_den,'..'
            for c_nom in c_list:
		[x_nom,x_den]=[0,1]
                comm_list=['./C_at_zero_p_con']
                comm_list+=[str(uniform_prior)]
                comm_list+=[str(U_is_derived)]
                comm_list+=[str(m_C)]
                comm_list+=[str(n)]
                comm_list+=[str(m_A)]
                comm_list+=[str(l_A)]
                comm_list+=[str(c_nom)]
                comm_list+=[str(c_den)]
                comm_list+=[str(x_nom)]
                comm_list+=[str(x_den)]
                comm_list+=[str(t_AC_nom)]
                comm_list+=[str(t_AC_den)]
                comm_list+=[str(the_prec)]
                comm_list+=[tav_error]
	 	#print comm_list
		#raw_input()
                a_proc=subprocess.Popen(comm_list, shell=False, stdin=subprocess.PIPE,stdout=subprocess.PIPE)
                the_res=a_proc.communicate()[0].split()
                #print '\tand C =',1.0*c_nom/c_den,'.. pX-nom',x_nom,'pX-den',x_den,'has min prob',the_res[0],'and max prob',the_res[1]
                print '\tand C =',1.0*c_nom/c_den
            	min_prob_OUT_DICT[t_AC_nom].update({c_nom:the_res[0]})
            	max_prob_OUT_DICT[t_AC_nom].update({c_nom:the_res[1]})
        outf=open('results/max_prob_'+file_name,'w')
        if (uniform_prior==1):
            outf.write('uniform prior\n')
        else:
            if (U_is_derived==1):
                outf.write('Griffiths prior with U derived\n')
            else:
                outf.write('Griffiths prior with U ancestral\n')
        outf.write('m_C=\t'+str(m_C)+'\tl_C=\t'+str(l_C)+'\tm_A=\t'+str(m_A)+'\tl_A=\t'+str(l_A)+'\n')   
        outf.write('tav error=\t'+tav_error+'\n')   
        out_str=generate_out_str(t_AC_den,c_den,max_prob_OUT_DICT)
        outf.write(out_str+'\n')
        outf.close()

        outf=open('results/min_prob_'+file_name,'w')
        if (uniform_prior==1):
            outf.write('uniform prior\n')
        else:
            if (U_is_derived==1):
                outf.write('Griffiths prior with U derived\n')
            else:
                outf.write('Griffiths prior with U ancestral\n')
        outf.write('m_C=\t'+str(m_C)+'\tl_C=\t'+str(l_C)+'\tm_A=\t'+str(m_A)+'\tl_A=\t'+str(l_A)+'\n')      
        outf.write('tav error=\t'+tav_error+'\n')   
        out_str=generate_out_str(t_AC_den,c_den,min_prob_OUT_DICT)
        outf.write(out_str+'\n')
        outf.close()
    else:
        print '\tGriffith\'s prior not defined for this case'
else:
    print '\tnot valid since U is more common in PopC than in PopA'

