#ifndef MAIN_PROBABILITIES
#define MAIN_PROBABILITIES


int function_Beta(mpq_t gmp_dummy,unsigned long int n,unsigned long int k);
int function_special_Beta(mpq_t gmp_dummy,bool prior_uniform, bool U_is_derived, unsigned long int n,unsigned long int k);
int function_myBin(mpq_t gmp_dummy,unsigned long int n,unsigned long int k,unsigned long int a_nom,unsigned long int a_den);
//int function_C(mpq_t gmp_dummy,unsigned long int n,unsigned long int k,unsigned long int c_nom,unsigned long int c_den);
//function_C and function_Bin are identical and return (n over k)c^(k)(1-c)^(n-k)
int check_which_case_H_func(unsigned long int j,unsigned long int i,unsigned long int m,unsigned long int k);
int function_H(mpq_t gmp_dummy,unsigned long int j,unsigned long int i,unsigned long int m,unsigned long int k);
int check_which_case_G_func(unsigned long int m,unsigned long int i);
int function_G(mpfr_t mpfr_dummy,unsigned long int m,unsigned long int i,unsigned long int t_nom,unsigned long int t_den, mp_rnd_t ROUND_MODE,mp_prec_t MY_PREC);
int function_S_uniform(mpq_t gmp_dummy,unsigned long int j,unsigned long int i,unsigned long int m,unsigned long int l);
int function_S_Griff(mpq_t gmp_dummy,unsigned long int j,unsigned long int i,unsigned long int m,unsigned long int l);
void function_S_generic(mpq_t gmp_dummy,bool prior_uniform, bool U_is_derived,unsigned long int j,unsigned long int i,unsigned long int m,unsigned long int l);
int calculate_Ptot_CatT(unsigned long int low_tav_val,unsigned long int high_tav_val, mpfr_t mpfr_BACK, ListNode* SENT_tav_vect, bool prior_uniform, bool U_is_derived, unsigned long int m, unsigned long int l, unsigned long int m_A,unsigned long int l_A,unsigned long int c_nom,unsigned long int c_den,unsigned long int t_ac_nom,unsigned long int t_ac_den, unsigned long int pX_nom, unsigned long int pX_den, mp_rnd_t ROUND_MODE,mp_prec_t MY_PREC);


#endif

int function_Beta(mpq_t gmp_dummy,unsigned long int n,unsigned long int k)
{
  mpz_t gmp_Local_A, gmp_Local_B;
  unsigned long int n_minus_1,k_minus_1,n_plus_k_minus_1;

  n_minus_1=n-1;
  k_minus_1=k-1;
  n_plus_k_minus_1=n+k-1;

  mpz_init(gmp_Local_A);
  mpz_init(gmp_Local_B);

  mpz_fac_ui(gmp_Local_A,n_minus_1);
  mpz_fac_ui(gmp_Local_B,k_minus_1);
  mpz_mul(gmp_Local_A,gmp_Local_A,gmp_Local_B);
  mpz_fac_ui(gmp_Local_B,n_plus_k_minus_1);

  mpq_set_num(gmp_dummy,gmp_Local_A);
  mpq_set_den(gmp_dummy,gmp_Local_B);
  mpq_canonicalize(gmp_dummy);
  mpz_clear(gmp_Local_A);
  mpz_clear(gmp_Local_B);
  mpfr_free_cache();
  return 0;
}

int function_special_Beta(mpq_t gmp_dummy,bool prior_uniform, bool U_is_derived, unsigned long int n,unsigned long int k)
{
  unsigned long int n_plus_1,k_plus_1;
  n_plus_1=n+1;
  k_plus_1=k+1;

  if (prior_uniform==true)
    {
      function_Beta(gmp_dummy,n_plus_1,k_plus_1);
    }
  else
    {
      if (U_is_derived==true)
        {
          function_Beta(gmp_dummy,n,k_plus_1);
        }
      else
        {
          function_Beta(gmp_dummy,n_plus_1,k);
        }
    }
  return 0;
}


int function_myBin(mpq_t gmp_dummy,unsigned long int n,unsigned long int k,unsigned long int a_nom,unsigned long int a_den)
{
  mpz_t gmp_Local_A, gmp_Local_B;
  unsigned long int a_diff,n_minus_k;

  a_diff=a_den-a_nom;
  n_minus_k=n-k;
  mpz_init(gmp_Local_A);
  mpz_init(gmp_Local_B);

  mpz_ui_pow_ui(gmp_Local_A,a_nom,k);
  mpz_ui_pow_ui(gmp_Local_B,a_diff,n_minus_k);
  mpz_mul(gmp_Local_A,gmp_Local_A,gmp_Local_B);
  mpz_bin_uiui(gmp_Local_B,n,k);
  mpz_mul(gmp_Local_A,gmp_Local_A,gmp_Local_B);
  mpz_ui_pow_ui(gmp_Local_B,a_den,n);

  mpq_set_num(gmp_dummy,gmp_Local_A);
  mpq_set_den(gmp_dummy,gmp_Local_B);
  mpq_canonicalize(gmp_dummy);
  mpz_clear(gmp_Local_A);
  mpz_clear(gmp_Local_B);
  mpfr_free_cache();
  return 0;
}


/* THIS DOESN'T WORK FOR SOME REASON
int function_C(mpq_t gmp_dummy,unsigned long int n,unsigned long int k,unsigned long int c_nom,unsigned long int c_den)
{
  function_Bin(mpq_t gmp_dummy,unsigned long int n,unsigned long int k,unsigned long int c_nom,unsigned long int c_den);
  return 0;
}
*/

int check_which_case_H_func(unsigned long int j,unsigned long int i,unsigned long int m,unsigned long int k)
{
  int ret_val;
  if (((j>0)&&(j<=m))&&((i>0)&&(i<=k)))
    {
      ret_val=2;
    }
  else
    {
      if (((j==0)&&(m==0))&&((i>0)&&(i<=k)))
	{
	  ret_val=1;
	}
      else
	{
	  if (((j>0)&&(j<=m))&&((i==0)&&(k==0)))
	    {
	      ret_val=1;
	    }
	  else
	    {
	      if (((j==0)&&(m==0))&&((i==0)&&(k==0)))
		{
		  ret_val=1;
		}
	      else
		{
		  ret_val=0;
		}
	    }
	}
    }
  return ret_val;
}

int function_H(mpq_t gmp_dummy,unsigned long int j,unsigned long int i,unsigned long int m,unsigned long int k)
{
  int case_indicator,ret_val=1;
  mpz_t gmp_Local_A, gmp_Local_B;
  mpz_init(gmp_Local_A);
  mpz_init(gmp_Local_B);
  case_indicator=check_which_case_H_func(j,i,m,k);
  if (case_indicator==0)
    {
      mpz_set_ui(gmp_Local_A,0);
      mpz_set_ui(gmp_Local_B,1);
      mpq_set_num(gmp_dummy,gmp_Local_A);
      mpq_set_den(gmp_dummy,gmp_Local_B);
      mpq_canonicalize(gmp_dummy);
    }
  else
    {
       if (case_indicator==1)
	 {
	   mpz_set_ui(gmp_Local_A,1);
	   mpz_set_ui(gmp_Local_B,1);
	   mpq_set_num(gmp_dummy,gmp_Local_A);
	   mpq_set_den(gmp_dummy,gmp_Local_B);
	   mpq_canonicalize(gmp_dummy);
	 }
       else
	 {
	   mpz_bin_uiui(gmp_Local_A,m-1,j-1);
	   mpz_bin_uiui(gmp_Local_B,k-1,i-1);
	   mpz_mul(gmp_Local_A,gmp_Local_A,gmp_Local_B);
	   mpz_bin_uiui(gmp_Local_B,m+k-1,j+i-1);
	   mpq_set_num(gmp_dummy,gmp_Local_A);
	   mpq_set_den(gmp_dummy,gmp_Local_B);
	   mpq_canonicalize(gmp_dummy);
	 }
    }
  mpz_clear(gmp_Local_A);
  mpz_clear(gmp_Local_B);
  mpfr_free_cache();
  return ret_val;
}


int check_which_case_G_func(unsigned long int m,unsigned long int i,unsigned long int t_nom)
{
  int ret_val;
  if (!(t_nom==0))
    {
      if ((0<i)&&(i<=m))
	{
	  ret_val=2;
	}
      else
	{
	  if ((i==0)&&(m==0))
	    {
	      ret_val=1;
	    }
	  else
	    {
	      ret_val=0;
	    }
	}
    }
  else
    {
      if (i==m)
	{
	  ret_val=1;
	}
      else
	{
	  ret_val=0;
	}
    }
  return ret_val;
}


int function_G(mpfr_t mpfr_dummy,unsigned long int m,unsigned long int i,unsigned long int t_nom,unsigned long int t_den, mp_rnd_t ROUND_MODE,mp_prec_t MY_PREC)
{
  int  case_indicator,non_negative,not_larger_than_one,ret_val=1;
  unsigned long int local_r;
  mpz_t gmp_Local_A, gmp_Local_B;
  mpfr_t mpfr_Local;

  case_indicator=check_which_case_G_func(m,i,t_nom);
  if (case_indicator==0)
    {
      mpfr_set_ui(mpfr_dummy,0,ROUND_MODE);
    }
  else
    {
      if (case_indicator==1)
	{
	  mpfr_set_ui(mpfr_dummy,1,ROUND_MODE);
	}
      else
	{
	  mpz_init(gmp_Local_A);
	  mpz_init(gmp_Local_B);
	  mpfr_init2(mpfr_Local,MY_PREC);
	  mpfr_set_ui(mpfr_dummy,0,ROUND_MODE);
	  if (i==1)
	    {
	      for (local_r=2; local_r<=m; local_r++)
		{
		  mpfr_set_ui(mpfr_Local,(local_r*local_r-local_r)*t_nom,ROUND_MODE);
		  mpfr_div_ui(mpfr_Local,mpfr_Local,2*t_den,ROUND_MODE);
		  mpfr_neg(mpfr_Local,mpfr_Local,ROUND_MODE);
		  mpfr_exp(mpfr_Local,mpfr_Local,ROUND_MODE);
		  mpfr_mul_ui(mpfr_Local,mpfr_Local,2*local_r-1,ROUND_MODE);
		  if (local_r%2==1)
		    {
		      mpfr_neg(mpfr_Local,mpfr_Local,ROUND_MODE);
		    }
		  mpz_bin_uiui(gmp_Local_A,m,local_r);
		  mpz_bin_uiui(gmp_Local_B,m+local_r-1,local_r);
		  mpfr_mul_z(mpfr_Local,mpfr_Local,gmp_Local_A,ROUND_MODE);
		  mpfr_div_z(mpfr_Local,mpfr_Local,gmp_Local_B,ROUND_MODE);
		  mpfr_add(mpfr_dummy,mpfr_dummy,mpfr_Local,ROUND_MODE);
		}
	      mpfr_neg(mpfr_dummy,mpfr_dummy,ROUND_MODE);
	      mpfr_add_ui(mpfr_dummy,mpfr_dummy,1,ROUND_MODE);
	    }
	  else
	    {
	      for (local_r=i; local_r<=m; local_r++)
		{
		  mpfr_set_ui(mpfr_Local,(local_r*local_r-local_r)*t_nom,ROUND_MODE);
		  mpfr_div_ui(mpfr_Local,mpfr_Local,2*t_den,ROUND_MODE);
		  mpfr_neg(mpfr_Local,mpfr_Local,ROUND_MODE);
		  mpfr_exp(mpfr_Local,mpfr_Local,ROUND_MODE);
		  mpfr_mul_ui(mpfr_Local,mpfr_Local,2*local_r-1,ROUND_MODE);
		  if ((local_r-i)%2==1)
		    {
		      mpfr_neg(mpfr_Local,mpfr_Local,ROUND_MODE);
		    }
		  mpz_bin_uiui(gmp_Local_A,m,local_r);

		  mpz_bin_uiui(gmp_Local_B,local_r,i);
		  mpz_mul(gmp_Local_A,gmp_Local_A,gmp_Local_B);

		  mpz_bin_uiui(gmp_Local_B,i+local_r-1,local_r);
		  mpz_mul(gmp_Local_A,gmp_Local_A,gmp_Local_B);

		  mpz_bin_uiui(gmp_Local_B,m+local_r-1,local_r);
		  mpz_mul_ui(gmp_Local_B,gmp_Local_B,i+local_r-1);

		  mpfr_mul_z(mpfr_Local,mpfr_Local,gmp_Local_A,ROUND_MODE);
		  mpfr_div_z(mpfr_Local,mpfr_Local,gmp_Local_B,ROUND_MODE);
		  mpfr_add(mpfr_dummy,mpfr_dummy,mpfr_Local,ROUND_MODE);
		}
	    }
	  non_negative=mpfr_cmp_ui(mpfr_dummy,0);
	  not_larger_than_one=-1*mpfr_cmp_ui(mpfr_dummy,1);
	  if ((non_negative<0)||(not_larger_than_one<0))
	    {
	      ret_val=0;
	    }
	  mpfr_clear(mpfr_Local);
	  mpz_clear(gmp_Local_A);
	  mpz_clear(gmp_Local_B);
	  mpfr_free_cache();
	}
    }
  return ret_val;
}


int function_S_uniform(mpq_t gmp_dummy,unsigned long int j,unsigned long int i,unsigned long int m,unsigned long int l)
{
  int ret_val=1;
  unsigned long int local_i;
  mpz_t gmp_Local_A, gmp_Local_B;
  
  mpz_init(gmp_Local_A);
  mpz_init(gmp_Local_B);
  if ((j==0)&&(i==0))
    {
      mpz_set_ui(gmp_Local_A,1);
      mpz_set_ui(gmp_Local_B,1);
      mpq_set_num(gmp_dummy,gmp_Local_A);
      mpq_set_den(gmp_dummy,gmp_Local_B);
      mpq_canonicalize(gmp_dummy);
    }
  else
    {
      mpz_set_ui(gmp_Local_A,1);
      for (local_i=m+1;local_i<=m+j;local_i++)
	{
	  mpz_mul_ui(gmp_Local_A,gmp_Local_A,local_i);
	}
      mpz_set_ui(gmp_Local_B,1);
      for (local_i=l+1;local_i<=l+i;local_i++)
	{
	  mpz_mul_ui(gmp_Local_B,gmp_Local_B,local_i);
	}
      mpz_mul(gmp_Local_A,gmp_Local_A,gmp_Local_B);
      mpz_bin_uiui(gmp_Local_B,i+j,j);
      mpz_mul(gmp_Local_A,gmp_Local_A,gmp_Local_B);
      mpz_set_ui(gmp_Local_B,1);
      for (local_i=m+l+2;local_i<=m+l+i+j+1;local_i++)
	{
	  mpz_mul_ui(gmp_Local_B,gmp_Local_B,local_i);
	}
      mpq_set_num(gmp_dummy,gmp_Local_A);
      mpq_set_den(gmp_dummy,gmp_Local_B);
      mpq_canonicalize(gmp_dummy);
    }
  mpz_clear(gmp_Local_A);
  mpz_clear(gmp_Local_B);
  mpfr_free_cache();
  return ret_val;
}



int function_S_Griff(mpq_t gmp_dummy,unsigned long int j,unsigned long int i,unsigned long int m,unsigned long int l)
{

  int ret_val=1;
  unsigned long int local_i;
  mpz_t gmp_Local_A, gmp_Local_B;
  mpq_t gmp_Local_rational;
 
  mpz_init(gmp_Local_A);
  mpz_init(gmp_Local_B);
  if ((j==0)&&(i==0))
    {
      mpq_set_ui(gmp_dummy,1,1);
    }
  else
    {
      if (m<1)
	{
	  ret_val=0;
	  mpq_set_ui(gmp_dummy,0,1);
	}
      else
	{
	  mpz_set_ui(gmp_Local_A,1);
	  for (local_i=m;local_i<=m+j-1;local_i++)
	    {
	      mpz_mul_ui(gmp_Local_A,gmp_Local_A,local_i);
	    }
	  mpz_set_ui(gmp_Local_B,1);
	  for (local_i=l+1;local_i<=l+i;local_i++)
	    {
	      mpz_mul_ui(gmp_Local_B,gmp_Local_B,local_i);
	    }
	  mpz_mul(gmp_Local_A,gmp_Local_A,gmp_Local_B);
	  mpz_bin_uiui(gmp_Local_B,i+j,j);
	  mpz_mul(gmp_Local_A,gmp_Local_A,gmp_Local_B);
	  mpz_set_ui(gmp_Local_B,1);
	  for (local_i=m+l+1;local_i<=m+l+i+j;local_i++)
	    {
	      mpz_mul_ui(gmp_Local_B,gmp_Local_B,local_i);
	    }
	  mpq_set_num(gmp_dummy,gmp_Local_A);
	  mpq_set_den(gmp_dummy,gmp_Local_B);
	  mpq_canonicalize(gmp_dummy);
	}
    }
  mpz_clear(gmp_Local_A);
  mpz_clear(gmp_Local_B);
  mpfr_free_cache();
  return ret_val;
}


void function_S_generic(mpq_t gmp_dummy,bool prior_uniform, bool U_is_derived,unsigned long int j,unsigned long int i,unsigned long int m,unsigned long int l)
{
 if (prior_uniform==true)
   {
     function_S_uniform(gmp_dummy,j,i-j,m,l);
   }
 else
   {
     if (U_is_derived==true)
       {
         function_S_Griff(gmp_dummy,j,i-j,m,l);
       }
     else
       {
         function_S_Griff(gmp_dummy,i-j,j,l,m);
       }
    }
}


int calculate_Ptot_CatT(unsigned long int low_tav_val,unsigned long int high_tav_val, mpfr_t mpfr_BACK, ListNode* SENT_tav_vect, bool prior_uniform, bool U_is_derived, unsigned long int m,unsigned long int l, unsigned long int m_A,unsigned long int l_A,unsigned long int c_nom,unsigned long int c_den,unsigned long int t_ac_nom,unsigned long int t_ac_den,  unsigned long int pX_nom, unsigned long int pX_den, mp_rnd_t ROUND_MODE,mp_prec_t MY_PREC)
{


  ListNode* Mpfr_tav_vect=SENT_tav_vect;
  ListNode* temp_node=NULL;
  mpfr_t* an_mpfr_ptr=NULL;


  mpfr_t mpfr_A,mpfr_E;
  mpq_t mpq_B,mpq_C,mpq_D;


  unsigned long int n;
  unsigned long int temp_ui_1,temp_ui_2;
  unsigned long int i,j,alpha,beta;



//INITIALISE MPFR AND GMP VARIABLES
  mpfr_init2(mpfr_A,MY_PREC);
  mpq_init(mpq_B);
  mpq_init(mpq_C);
  mpq_init(mpq_D);
  mpfr_init2(mpfr_E,MY_PREC);


  ///////////////////////////////
 //HERE ARE CALCULATIONS FOR THE DENOMINATOR WITH STUCTURE:
  /*
    A=0  (MPFR)
    for (alpha=0;alpha<=m;alpha++)
      {
	for (beta=0;beta<=l;beta++)
	  {
            C=0 (GMP)
	    for (i=0;i<=alpha;i++)
	      {
                for (j=0;j<=beta;j++)
                  {
		     C=C+func_my_Bin(i+j,alpha+beta,c)*func_S(i,j,c)*func_my_Bin(alpha-i,alpha+beta-i-j,pX) (GMP)
                  }//j-loop
              }//i-loop
	    B=C*func_H(alpha,beta,m,l) (GMP)
	    A=A+B*func_G(n,alpha+beta,t) (MPFR)
          }//beta-loop
       }//alpha-loop
    return (A)
  */


  n=m+l;
  mpfr_set_ui(mpfr_A,0,ROUND_MODE);
  for (alpha=0;alpha<=m;alpha++)
    {
      for (beta=0;beta<=l;beta++)
        {
	  if ((alpha+beta>=low_tav_val) && (alpha+beta<=high_tav_val))
	   {
	     mpq_set_ui(mpq_B,0,1);
             for (i=0;i<=alpha;i++)
	       {
                 for (j=0;j<=beta;j++)
                   {
                     function_S_generic(mpq_C,prior_uniform, U_is_derived,i,i+j,m_A,l_A);
                     temp_ui_1=i+j;
                     temp_ui_2=alpha+beta;
	       	     function_myBin(mpq_D,temp_ui_2,temp_ui_1,c_nom,c_den);
  		     mpq_mul(mpq_C,mpq_C,mpq_D);
                     mpq_canonicalize(mpq_C);
 		     temp_ui_1=alpha-i;
                     temp_ui_2=alpha+beta-i-j;
	       	     function_myBin(mpq_D,temp_ui_2,temp_ui_1,pX_nom,pX_den);
                     mpq_mul(mpq_C,mpq_C,mpq_D);
                     mpq_canonicalize(mpq_C);
                     mpq_add(mpq_B,mpq_B,mpq_C);
                     mpq_canonicalize(mpq_B);
                   }//j-loop
	       }//i-loop
	     function_H(mpq_C,alpha,beta,m,l);
    	     mpq_mul(mpq_B,mpq_B,mpq_C);
             mpq_canonicalize(mpq_B);
	     temp_ui_1=alpha+beta;
             temp_node=Mpfr_tav_vect->GetBetaAlphaNode(Mpfr_tav_vect,n,temp_ui_1);
             an_mpfr_ptr=temp_node->GetMpfr();
	     mpfr_set(mpfr_E,*an_mpfr_ptr,ROUND_MODE);
	     temp_node=NULL;
	     an_mpfr_ptr=NULL;
	     mpfr_mul_q(mpfr_E,mpfr_E,mpq_B,ROUND_MODE);
	     mpfr_add(mpfr_A,mpfr_A,mpfr_E,ROUND_MODE);
           }//if in relevant Tav vals
	} //beta-loop
    }//alpha-loop
  mpfr_swap(mpfr_BACK,mpfr_A);
  mpfr_clear(mpfr_E);
  mpq_clear(mpq_D);
  mpq_clear(mpq_C);
  mpq_clear(mpq_B);
  mpfr_clear(mpfr_A);
  mpfr_free_cache();
  return 0;
}

