


args <- commandArgs(trailingOnly = TRUE)
InName=args[1]

myD=read.table(paste("../demographic_p_con/results/max_prob_",InName,"_demographic.txt",sep=""),skip=4)
myC=as.numeric(substr(names(myD),2,10))

myD=read.table(paste("../demographic_p_con/results/max_prob_",InName,"_demographic.txt",sep=""),skip=5)
myT=myD[,1]
maxD=myD[,2:dim(myD)[2]]
myD=read.table(paste("../demographic_p_con/results/min_prob_",InName,"_demographic.txt",sep=""),skip=5)
minD=myD[,2:dim(myD)[2]]
myD=NULL

#myIndexList=c(1,2,3,4,5,6,7,9,11,13,15,17,19,21)
myIndexList=c(1:length(myC))
boxSpace1=0.004
boxSpace2=0.003


pdf(paste("figures/",InName,"_demographic.pdf",sep=""))
plot(myT,maxD[,1],ylim=c(0,1),ylab='p_con',xlab='Gmin/Nmax < T < Gmax/Nmin',type='n',xaxt='n',yaxt='n')
axis(2, at = c(0,0.05,0.25,0.5,0.75,1), las=1)
axis(1, at = myT, las=1)
for (i in 1:dim(maxD)[2]){
lines(myT,maxD[,i],col='blue')
lines(myT,minD[,i],col='red')
}
abline(h=0.05,lty=2)
abline(h=0,lty=1)
for (i in 1:length(myIndexList)) {rect(myT[i]-boxSpace2,maxD[i,myIndexList[i]]-boxSpace1,myT[i]+boxSpace2,maxD[i,myIndexList[i]]+boxSpace1,col='white',border=NA,lwd=0)}
for (i in 1:length(myIndexList)) {text(myT[i],maxD[i,myIndexList[i]],label=as.character(myC[myIndexList[i]]),cex=0.7,col='black')}
dev.off()
