args <- commandArgs(trailingOnly = TRUE)
InName=args[1]


tempD=read.table(paste("../simulation_code/results/",InName,"_genetic_res.txt",sep=""))
myC=NULL
temp=colnames(tempD)
for (i in 1:length(temp)){myC=c(myC,as.numeric(substring(temp[i],2,5)))}
myT=NULL
temp=rownames(tempD)
for (i in 1:length(temp)){myT=c(myT,as.numeric(temp[i]))}
simPs=tempD



myIndexList=c(1:length(myC))
boxSpace1=0.004
boxSpace2=0.003


pdf(paste("figures/",InName,"_simulated_genetic.pdf",sep=""))
plot(myT,simPs[,1],ylim=c(0,1),ylab='p_con',xlab='Gmin/Nmax < T < Gmax/Nmin',type='n',xaxt='n',yaxt='n')
axis(2, at = c(0,0.05,0.25,0.5,0.75,1), las=1)
axis(1, at = myT, las=1)
for (i in 1:length(myC)){lines(myT,simPs[,i],type='b',pch=19,cex=0.4)}

abline(h=0.05,lty=2)
abline(h=0,lty=1)
for (i in 1:length(myIndexList)) {rect(myT[i]-boxSpace2,simPs[i,myIndexList[i]]-boxSpace1,myT[i]+boxSpace2,simPs[i,myIndexList[i]]+boxSpace1,col='white',border=NA,lwd=0)}
for (i in 1:length(myIndexList)) {text(myT[i],simPs[i,myIndexList[i]],label=as.character(myC[myIndexList[i]]),cex=0.7,col='black')}
dev.off()
