
##################### USER SPECIFY HERE ################
outName='test'
mymC=2
mylC=48
mymA=11
mylA=9
CindexDen=10
Cmin=1
Cmax=10
TindexDen=100
Tmin=0
Tmax=6
numReps=10000
mypX=0
#########################################################


simulatemC<-function(mC,nC,mZero,nZero){
numU=mZero
numTot=nZero
while(numTot<nC){
aUnif=runif(1)
if (aUnif<=numU/numTot){numU=numU+1}
numTot=numTot+1
}
return(numU)
}


generateSample<-function(mC,nC,mA,nA,theT,pX,theC){
acumT=0
tempn=nC
while ((acumT<=theT)&(tempn>0)){
if (tempn>1){acumT=acumT+rexp(1,0.5*tempn*(tempn-1))}
tempn=tempn-1
}
nZero=tempn+1
pTot=(1-theC)*pX+theC*rbeta(1,mA+1,nA-mA+1)
mZero=rbinom(1,nZero,pTot)

mCsim=simulatemC(mC,nC,mZero,nZero)
return(mCsim)
}


generatePcon<-function(nReps,mC,nC,mA,nA,theT,pX,theC){
theCounts=rep(0,nC+1)
doneReps=0
numLessThan=0
thresh=nC*(mA/nA)
while (doneReps<nReps){
aNum=generateSample(mC,nC,mA,nA,theT,pX,theC)
if (aNum<=thresh)
{
doneReps=doneReps+1
if (aNum<=mC){numLessThan=numLessThan+1}
}
}
return(numLessThan/nReps)
}


mynC=mymC+mylC
mynA=mymA+mylA



TList=NULL
for (Tindex in Tmin:Tmax){
 myT=1.0*Tindex/TindexDen
 TList=c(TList,myT)
}



CList=NULL
for (Cindex in Cmin:Cmax){
 myC=1.0*Cindex/CindexDen
 CList=c(CList,myC)
}

theRes=NULL
for (Tindex in 1:length(TList)){
 tempRes=NULL
 myT=TList[Tindex]
 for (Cindex in 1:length(CList)){
  myC=CList[Cindex]
  cat('simulating T=',myT,' and C=',myC,'\n')
  thePval=generatePcon(numReps,mymC,mynC,mymA,mynA,myT,mypX,myC)
  tempRes=cbind(tempRes,thePval)
 }#Cindex
 theRes=rbind(theRes,tempRes)
}#Tindex


write.table(theRes,file=paste("results/",outName,"_demographic_res.txt",sep=""),sep="\t",row.names=TList,col.names=CList,quote=FALSE)

